## mupdf 1.19.0+ds1

=== Makefile ===
# GNU Makefile

-include user.make

ifndef build
  build := release
endif

default: all

include Makerules

ifndef OUT
  OUT := build/$(build_prefix)$(build)$(build_suffix)
endif

include Makethird

# --- Configuration ---

# Do not specify CFLAGS or LIBS on the make invocation line - specify
# XCFLAGS or XLIBS instead. Make ignores any lines in the makefile that
# set a variable that was set on the command line.
CFLAGS += $(XCFLAGS) -Iinclude
LIBS += $(XLIBS) -lm

ifneq ($(threading),no)
  ifeq ($(HAVE_PTHREAD),yes)
	THREADING_CFLAGS := $(PTHREAD_CFLAGS) -DHAVE_PTHREAD
	THREADING_LIBS := $(PTHREAD_LIBS)
  endif
endif

ifeq ($(HAVE_WIN32),yes)
  WIN32_LIBS := -lcomdlg32 -lgdi32
  WIN32_LDFLAGS := -Wl,-subsystem,windows
endif

# --- Commands ---

ifneq ($(verbose),yes)
  QUIET_AR = @ echo "    AR $@" ;
  QUIET_RANLIB = @ echo "    RANLIB $@" ;
  QUIET_CC = @ echo "    CC $@" ;
  QUIET_CXX = @ echo "    CXX $@" ;
  QUIET_GEN = @ echo "    GEN $@" ;
  QUIET_LINK = @ echo "    LINK $@" ;
  QUIET_RM = @ echo "    RM $@" ;
  QUIET_TAGS = @ echo "    TAGS $@" ;
  QUIET_WINDRES = @ echo "    WINDRES $@" ;
  QUIET_OBJCOPY = @ echo "    OBJCOPY $@" ;
  QUIET_DLLTOOL = @ echo "    DLLTOOL $@" ;
  QUIET_GENDEF = @ echo "    GENDEF $@" ;
endif

MKTGTDIR = mkdir -p $(dir $@)
CC_CMD = $(QUIET_CC) $(MKTGTDIR) ; $(CC) $(CFLAGS) -MMD -MP -o $@ -c $<
CXX_CMD = $(QUIET_CXX) $(MKTGTDIR) ; $(CXX) $(CFLAGS) $(XCXXFLAGS) -MMD -MP -o $@ -c $<
AR_CMD = $(QUIET_AR) $(MKTGTDIR) ; $(AR) cr $@ $^
ifdef RANLIB
  RANLIB_CMD = $(QUIET_RANLIB) $(RANLIB) $@
endif
LINK_CMD = $(QUIET_LINK) $(MKTGTDIR) ; $(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
TAGS_CMD = $(QUIET_TAGS) ctags -R --c-kinds=+p --exclude=platform/python --exclude=platform/c++
WINDRES_CMD = $(QUIET_WINDRES) $(MKTGTDIR) ; $(WINDRES) $< $@
OBJCOPY_CMD = $(QUIET_OBJCOPY) $(MKTGTDIR) ; $(LD) -r -b binary -z noexecstack -o $@ $<
GENDEF_CMD = $(QUIET_GENDEF) gendef - $< > $@
DLLTOOL_CMD = $(QUIET_DLLTOOL) dlltool -d $< -D $(notdir $(^:%.def=%.dll)) -l $@

ifeq ($(shared),yes)
LINK_CMD = $(QUIET_LINK) $(MKTGTDIR) ; $(CC) $(LDFLAGS) -o $@ \
	$(filter-out %.$(SO),$^) \
	$(sort $(patsubst %,-L%,$(dir $(filter %.$(SO),$^)))) \
	$(patsubst lib%.$(SO),-l%,$(notdir $(filter %.$(SO),$^))) \
	$(LIBS)
endif

# --- Rules ---

$(OUT)/%.a :
	$(AR_CMD)
	$(RANLIB_CMD)

$(OUT)/%.exe: %.c
	$(LINK_CMD)

$(OUT)/%.$(SO):
	$(LINK_CMD) $(LIB_LDFLAGS) $(THIRD_LIBS) $(LIBCRYPTO_LIBS)

$(OUT)/%.def: $(OUT)/%.$(SO)
	$(GENDEF_CMD)

$(OUT)/%_$(SO).a: $(OUT)/%.def
	$(DLLTOOL_CMD)

$(OUT)/source/helpers/mu-threads/%.o : source/helpers/mu-threads/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THREADING_CFLAGS)

$(OUT)/source/helpers/pkcs7/%.o : source/helpers/pkcs7/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(LIBCRYPTO_CFLAGS)

$(OUT)/source/tools/%.o : source/tools/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(THIRD_CFLAGS) $(THREADING_CFLAGS)

$(OUT)/generated/%.o : generated/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) -O0

$(OUT)/platform/x11/%.o : platform/x11/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(X11_CFLAGS)

$(OUT)/platform/x11/curl/%.o : platform/x11/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(X11_CFLAGS) $(CURL_CFLAGS)

$(OUT)/platform/gl/%.o : platform/gl/%.c
	$(CC_CMD) $(WARNING_CFLAGS) $(THIRD_CFLAGS) $(THIRD_GLUT_CFLAGS)

ifeq ($(HAVE_OBJCOPY),yes)
  $(OUT)/source/fitz/noto.o : source/fitz/noto.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement -DHAVE_OBJCOPY $(LIB_CFLAGS) $(THIRD_CFLAGS)
endif

$(OUT)/source/fitz/memento.o : source/fitz/memento.c
	$(CC_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) -DMEMENTO_MUPDF_HACKS

$(OUT)/source/%.o : source/%.c
	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement $(LIB_CFLAGS) $(THIRD_CFLAGS)

$(OUT)/source/%.o : source/%.cpp
	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(TESSERACT_BUILD_CFLAGS)

$(OUT)/platform/%.o : platform/%.c
	$(CC_CMD) $(WARNING_CFLAGS)

$(OUT)/%.o: %.rc
	$(WINDRES_CMD)

.PRECIOUS : $(OUT)/%.o # Keep intermediates from chained rules
.PRECIOUS : $(OUT)/%.exe # Keep intermediates from chained rules

# --- File lists ---

THIRD_OBJ := $(THIRD_SRC:%.c=$(OUT)/%.o)
THIRD_OBJ := $(THIRD_OBJ:%.cc=$(OUT)/%.o)
THIRD_OBJ := $(THIRD_OBJ:%.cpp=$(OUT)/%.o)

THIRD_GLUT_OBJ := $(THIRD_GLUT_SRC:%.c=$(OUT)/%.o)

MUPDF_SRC := $(sort $(wildcard source/fitz/*.c))
MUPDF_SRC += $(sort $(wildcard source/fitz/*.cpp))
MUPDF_SRC += $(sort $(wildcard source/pdf/*.c))
MUPDF_SRC += $(sort $(wildcard source/xps/*.c))
MUPDF_SRC += $(sort $(wildcard source/svg/*.c))
MUPDF_SRC += $(sort $(wildcard source/html/*.c))
MUPDF_SRC += $(sort $(wildcard source/reflow/*.c))
MUPDF_SRC += $(sort $(wildcard source/cbz/*.c))

MUPDF_OBJ := $(MUPDF_SRC:%.c=$(OUT)/%.o)
MUPDF_OBJ := $(MUPDF_OBJ:%.cpp=$(OUT)/%.o)

THREAD_SRC := source/helpers/mu-threads/mu-threads.c
THREAD_OBJ := $(THREAD_SRC:%.c=$(OUT)/%.o)

PKCS7_SRC += source/helpers/pkcs7/pkcs7-openssl.c
PKCS7_OBJ := $(PKCS7_SRC:%.c=$(OUT)/%.o)

# --- Generated embedded font files ---

HEXDUMP_EXE := $(OUT)/scripts/hexdump.exe

FONT_BIN := $(sort $(wildcard resources/fonts/urw/*.cff))
FONT_BIN += $(sort $(wildcard resources/fonts/han/*.ttc))
FONT_BIN += $(sort $(wildcard resources/fonts/droid/*.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.otf))
FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.ttf))
FONT_BIN += $(sort $(wildcard resources/fonts/sil/*.cff))

FONT_GEN := $(FONT_BIN:%=generated/%.c)

generated/%.cff.c : %.cff $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
generated/%.otf.c : %.otf $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
generated/%.ttf.c : %.ttf $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
generated/%.ttc.c : %.ttc $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<

ifeq ($(HAVE_OBJCOPY),yes)
  MUPDF_OBJ += $(FONT_BIN:%=$(OUT)/%.o)
  $(OUT)/%.cff.o : %.cff ; $(OBJCOPY_CMD)
  $(OUT)/%.otf.o : %.otf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttf.o : %.ttf ; $(OBJCOPY_CMD)
  $(OUT)/%.ttc.o : %.ttc ; $(OBJCOPY_CMD)
else
  MUPDF_OBJ += $(FONT_GEN:%.c=$(OUT)/%.o)
endif

generate: $(FONT_GEN)

# --- Generated ICC profiles ---

source/fitz/icc/%.icc.h: resources/icc/%.icc
	$(QUIET_GEN) xxd -i $< | \
		sed 's/unsigned/static const unsigned/' | \
		sed '1i// This is an automatically generated file. Do not edit.' \
		> $@

generate: source/fitz/icc/gray.icc.h
generate: source/fitz/icc/rgb.icc.h
generate: source/fitz/icc/cmyk.icc.h
generate: source/fitz/icc/lab.icc.h

# --- Generated CMap files ---

CMAP_GEN := $(notdir $(sort $(wildcard resources/cmaps/*)))
CMAP_GEN := $(CMAP_GEN:%=source/pdf/cmaps/%.h)

source/pdf/cmaps/%.h: resources/cmaps/% scripts/cmapdump.py
	$(QUIET_GEN) python3 scripts/cmapdump.py > $@ $<

generate: $(CMAP_GEN)

# --- Generated embedded javascript files ---

source/pdf/js/%.js.h: source/pdf/js/%.js scripts/jsdump.sed
	$(QUIET_GEN) sed -f scripts/jsdump.sed < $< > $@

generate: source/pdf/js/util.js.h

# --- Generated perfect hash source files ---

source/html/css-properties.h: source/html/css-properties.gperf
	$(QUIET_GEN) gperf > $@ $<

generate: source/html/css-properties.h

# --- Library ---

ifeq ($(shared),yes)
MUPDF_LIB = $(OUT)/libmupdf.$(SO)
ifeq ($(OS),MINGW)
MUPDF_LIB_IMPORT = $(OUT)/libmupdf_$(SO).a
LIBS_TO_INSTALL_IN_BIN = $(MUPDF_LIB)
LIBS_TO_INSTALL_IN_LIB = $(MUPDF_LIB_IMPORT)
else
LIBS_TO_INSTALL_IN_LIB = $(MUPDF_LIB)
endif
ifneq ($(USE_SYSTEM_GLUT),yes)
THIRD_GLUT_LIB = $(OUT)/libmupdf-glut.a
endif
THREAD_LIB = $(OUT)/libmupdf-threads.a
PKCS7_LIB = $(OUT)/libmupdf-pkcs7.a

$(MUPDF_LIB) : $(MUPDF_OBJ) $(THIRD_OBJ)
$(THIRD_GLUT_LIB) : $(THIRD_GLUT_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)
$(PKCS7_LIB) : $(PKCS7_OBJ)
else
MUPDF_LIB = $(OUT)/libmupdf.a
LIBS_TO_INSTALL_IN_LIB = $(MUPDF_LIB) $(THIRD_LIB)
THIRD_LIB = $(OUT)/libmupdf-third.a
ifneq ($(USE_SYSTEM_GLUT),yes)
THIRD_GLUT_LIB = $(OUT)/libmupdf-glut.a
endif
THREAD_LIB = $(OUT)/libmupdf-threads.a
PKCS7_LIB = $(OUT)/libmupdf-pkcs7.a

$(MUPDF_LIB) : $(MUPDF_OBJ)
$(THIRD_LIB) : $(THIRD_OBJ)
$(THIRD_GLUT_LIB) : $(THIRD_GLUT_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)
$(PKCS7_LIB) : $(PKCS7_OBJ)
endif

$(MUPDF_LIB) : $(MUPDF_OBJ)
$(THIRD_LIB) : $(THIRD_OBJ)
$(THREAD_LIB) : $(THREAD_OBJ)
$(PKCS7_LIB) : $(PKCS7_OBJ)

# --- Main tools and viewers ---

MUTOOL_SRC := source/tools/mutool.c
MUTOOL_SRC += source/tools/muconvert.c
MUTOOL_SRC += source/tools/mudraw.c
MUTOOL_SRC += source/tools/murun.c
MUTOOL_SRC += source/tools/mutrace.c
MUTOOL_SRC += source/tools/cmapdump.c
MUTOOL_SRC += $(sort $(wildcard source/tools/pdf*.c))
MUTOOL_OBJ := $(MUTOOL_SRC:%.c=$(OUT)/%.o)
MUTOOL_EXE := $(OUT)/mutool
$(MUTOOL_EXE) : $(MUTOOL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(THREADING_LIBS) $(LIBCRYPTO_LIBS)
TOOL_APPS += $(MUTOOL_EXE)

MURASTER_OBJ := $(OUT)/source/tools/muraster.o
MURASTER_EXE := $(OUT)/muraster
$(MURASTER_EXE) : $(MURASTER_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(THREAD_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(THREADING_LIBS) $(LIBCRYPTO_LIBS)
TOOL_APPS += $(MURASTER_EXE)

ifeq ($(HAVE_GLUT),yes)
  MUVIEW_GLUT_SRC += $(sort $(wildcard platform/gl/*.c))
  MUVIEW_GLUT_OBJ := $(MUVIEW_GLUT_SRC:%.c=$(OUT)/%.o)
  MUVIEW_GLUT_EXE := $(OUT)/mupdf-gl
  $(MUVIEW_GLUT_EXE) : $(MUVIEW_GLUT_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(THIRD_GLUT_LIB) $(PKCS7_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(LIBCRYPTO_LIBS) $(WIN32_LDFLAGS) $(THIRD_GLUT_LIBS)
  VIEW_APPS += $(MUVIEW_GLUT_EXE)
endif

ifeq ($(HAVE_X11),yes)
  MUVIEW_X11_EXE := $(OUT)/mupdf-x11
  MUVIEW_X11_OBJ += $(OUT)/platform/x11/pdfapp.o
  MUVIEW_X11_OBJ += $(OUT)/platform/x11/x11_main.o
  MUVIEW_X11_OBJ += $(OUT)/platform/x11/x11_image.o
  $(MUVIEW_X11_EXE) : $(MUVIEW_X11_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(X11_LIBS) $(LIBCRYPTO_LIBS)
  VIEW_APPS += $(MUVIEW_X11_EXE)
endif

ifeq ($(HAVE_WIN32),yes)
  MUVIEW_WIN32_EXE := $(OUT)/mupdf-w32
  MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/pdfapp.o
  MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/win_main.o
  MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/win_res.o
  $(MUVIEW_WIN32_EXE) : $(MUVIEW_WIN32_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(WIN32_LDFLAGS) $(WIN32_LIBS) $(LIBCRYPTO_LIBS)
  VIEW_APPS += $(MUVIEW_WIN32_EXE)
endif

ifeq ($(HAVE_X11),yes)
ifeq ($(HAVE_CURL),yes)
ifeq ($(HAVE_PTHREAD),yes)
  MUVIEW_X11_CURL_EXE := $(OUT)/mupdf-x11-curl
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/pdfapp.o
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_main.o
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_image.o
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/curl_stream.o
  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/prog_stream.o
  $(MUVIEW_X11_CURL_EXE) : $(MUVIEW_X11_CURL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(CURL_LIB)
	$(LINK_CMD) $(THIRD_LIBS) $(X11_LIBS) $(LIBCRYPTO_LIBS) $(CURL_LIBS) $(PTHREAD_LIBS)
  VIEW_APPS += $(MUVIEW_X11_CURL_EXE)
endif
endif
endif

# --- Generated dependencies ---

-include $(MUPDF_OBJ:%.o=%.d)
-include $(PKCS7_OBJ:%.o=%.d)
-include $(THREAD_OBJ:%.o=%.d)
-include $(THIRD_OBJ:%.o=%.d)
-include $(THIRD_GLUT_OBJ:%.o=%.d)

-include $(MUTOOL_OBJ:%.o=%.d)
-include $(MUVIEW_GLUT_OBJ:%.o=%.d)
-include $(MUVIEW_X11_OBJ:%.o=%.d)
-include $(MUVIEW_WIN32_OBJ:%.o=%.d)

-include $(MURASTER_OBJ:%.o=%.d)
-include $(MUVIEW_X11_CURL_OBJ:%.o=%.d)

# --- Examples ---

examples: $(OUT)/example $(OUT)/multi-threaded

$(OUT)/example: docs/examples/example.c $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD) $(CFLAGS) $(THIRD_LIBS)
$(OUT)/multi-threaded: docs/examples/multi-threaded.c $(MUPDF_LIB) $(THIRD_LIB)
	$(LINK_CMD) $(CFLAGS) $(THIRD_LIBS) -lpthread

# --- Update version string header ---

VERSION = $(shell git describe --tags)

version:
	sed -i~ -e '/FZ_VERSION /s/".*"/"'$(VERSION)'"/' include/mupdf/fitz/version.h

# --- Format man pages ---

%.txt: %.1
	nroff -man $< | col -b | expand > $@

MAN_FILES := $(sort $(wildcard docs/man/*.1))
TXT_FILES := $(MAN_FILES:%.1=%.txt)

catman: $(TXT_FILES)

# --- Install ---

=== platform/java/Makefile ===
# GNU Makefile

-include ../../user.make

OS ?= $(shell uname)

JAVA := java
JAVAC := javac

ifndef build
  build := release
endif

ifeq ($(build),debug)
  BUILD_FLAGS := -DDEBUG -O0 -g
else ifeq ($(build),memento)
  BUILD_FLAGS := -DDEBUG -O0 -g -DMEMENTO
else
  BUILD_FLAGS := -DNDEBUG -O2
endif

ifndef OUT
  OUT := build/java/$(build)
endif

ifeq ($(OS),Darwin)
MUPDF_JAVA := ../../$(OUT)/libmupdf_java64.jnilib
JAVA_VM := $(shell /usr/libexec/java_home)
JAVA_CFLAGS := \
	-I $(JAVA_VM)/include \
	-I $(JAVA_VM)/include/darwin
JAVA_LDFLAGS :=

else

BITS := $(shell getconf LONG_BIT)

JAVA_HOME ?= /usr/lib/jvm/default-java

MUPDF_JAVA := ../../$(OUT)/libmupdf_java$(BITS).so
JAVA_CFLAGS := \
	-I $(JAVA_HOME)/include \
	-I $(JAVA_HOME)/include/linux \
	$(shell pkg-config --cflags freetype2) \
	$(shell pkg-config --cflags libcrypto)
JAVA_LIBS := \
	$(shell pkg-config --libs freetype2) \
	$(shell pkg-config --libs libcrypto) \
	-lz
JAVA_LDFLAGS := \
	-z noexecstack

ifeq ($(USE_TESSERACT), yes)
ifeq ($(USE_SYSTEM_TESSERACT), yes)
JAVA_LIBS += \
	$(shell pkg-config --libs lept) \
	$(shell pkg-config --libs tesseract)

CONFIGFLAGS += USE_SYSTEM_TESSERACT=yes
else
CONFIGFLAGS += USE_TESSERACT=yes
endif
endif
endif

MUPDF_JAR := ../../$(OUT)/libmupdf.jar

default: $(MUPDF_JAVA) $(MUPDF_JAR) $(EXAMPLE_JAVA_SOURCES)

MUPDF_CORE := ../../$(OUT)/libmupdf.a ../../$(OUT)/libmupdf-third.a
ifeq "$(OS)" "Linux"
$(MUPDF_CORE) : .FORCE
	$(MAKE) -C ../.. OUT=$(OUT) XCFLAGS=-fPIC build=$(build) USE_SYSTEM_FREETYPE=yes USE_SYSTEM_ZLIB=yes $(CONFIGFLAGS) libs
else
$(MUPDF_CORE) : .FORCE
	$(MAKE) -C ../.. OUT=$(OUT) XCFLAGS=-fPIC build=$(build) $(CONFIGFLAGS) libs
endif

LIBRARY_JAVA_SOURCES := $(sort $(wildcard src/com/artifex/mupdf/fitz/*.java))
LIBRARY_JAVA_OBJECTS := $(subst src/,../../$(OUT)/,$(LIBRARY_JAVA_SOURCES:%.java=%.class))
LIBRARY_JAVA_CLASSES := $(subst src/com/artifex/mupdf/fitz/,com.artifex.mupdf.fitz.,$(LIBRARY_JAVA_SOURCES:%.java=%))

JAVAC_FLAGS := $(JAVAC_XFLAGS) -source 1.7 -target 1.7

$(LIBRARY_JAVA_OBJECTS) : $(LIBRARY_JAVA_SOURCES)
	mkdir -p ../../$(OUT)
	$(JAVAC) $(JAVAC_FLAGS) -h ../../$(OUT)/ -d ../../$(OUT)/ $^

EXAMPLE_JAVA_SOURCES := $(sort $(wildcard example/*.java))
EXAMPLE_JAVA_OBJECTS := $(subst example/,../../$(OUT)/example/,$(EXAMPLE_JAVA_SOURCES:%.java=%.class))

$(EXAMPLE_JAVA_OBJECTS): $(EXAMPLE_JAVA_SOURCES)
	$(JAVAC) $(JAVAC_FLAGS) -classpath ../../$(OUT) -d ../../$(OUT)/ $^

REPATHED_LIBRARY_JAVA_OBJECTS := $(subst src/,,$(LIBRARY_JAVA_SOURCES:%.java=%.class))
$(MUPDF_JAR) : $(LIBRARY_JAVA_OBJECTS)
	rm -f $@
	cd ../../$(OUT) && jar cf libmupdf.jar $(REPATHED_LIBRARY_JAVA_OBJECTS)

mupdf_native.h : $(LIBRARY_JAVA_OBJECTS)
	rm -f $@
	cat $(sort $(wildcard ../../$(OUT)/*.h)) > mupdf_native.h

../../$(OUT)/mupdf_native.o : mupdf_native.c mupdf_native.h $(wildcard jni/*.c) $(MUPDF_CORE)
	$(CC) -g -o $@ -c $< -fPIC -Wall -Wextra -Wno-unused-parameter -Wpedantic -I ../../include \
		$(JAVA_CFLAGS) $(BUILD_FLAGS)

$(MUPDF_JAVA) : ../../$(OUT)/mupdf_native.o $(MUPDF_CORE)
	$(CC) -shared $(JAVA_LDFLAGS) -o $(MUPDF_JAVA) $^ $(JAVA_LIBS) $(BUILD_FLAGS)

run: $(MUPDF_JAVA) $(EXAMPLE_JAVA_OBJECTS) $(MUPDF_JAR)
	$(JAVA) -classpath ../../$(OUT)/ -Djava.library.path="../../$(OUT)" example.Viewer $$MUPDF_ARGS

gdb: $(MUPDF_JAVA) $(EXAMPLE_JAVA_OBJECTS) $(MUPDF_JAR)
	gdb --args $(JAVA) -classpath ../../$(OUT) -Djava.library.path="../../$(OUT)" example.Viewer $$MUPDF_ARGS

clean:
	rm -f $(LIBRARY_JAVA_OBJECTS) $(subst .class,\$$*.class,$(LIBRARY_JAVA_OBJECTS))
	rm -f $(EXAMPLE_JAVA_OBJECTS) $(subst .class,\$$*.class,$(EXAMPLE_JAVA_OBJECTS))
	rm -f ../../$(OUT)/mupdf_native.o
	rm -fr ../../$(OUT)/resources
	rm -fr ../../$(OUT)/source
	rm -fr ../../$(OUT)/thirdparty
	rm -f $(MUPDF_JAR)
	rm -f $(MUPDF_JAVA)
	rm -f ../../$(OUT)/*.h

nuke: clean
	$(MAKE) -C ../.. OUT=$(OUT) build=$(build) clean

.NOTPARALLEL : # disable -j option (it breaks since javac compiles all class files in one command)
.PHONY: .FORCE

=== platform/wasm/Makefile ===
MUPDF_JS := libmupdf.js
MUPDF_WASM := libmupdf.wasm

SAMPLE_PDF := pdfref13.pdf

all: $(MUPDF_JS)

EMSDK_DIR := /opt/emsdk
MUPDF_CORE := ../../build/wasm/libmupdf.a ../../build/wasm/libmupdf-third.a
$(MUPDF_CORE) : .FORCE
	$(MAKE) -j4 -C ../.. \
		OUT=wasm build=release \
		XCFLAGS='-DTOFU -DTOFU_CJK -DFZ_ENABLE_SVG=0 -DFZ_ENABLE_HTML=0 -DFZ_ENABLE_EPUB=0 -DFZ_ENABLE_JS=0' \
		generate
	BASH_SOURCE=$(EMSDK_DIR)/emsdk_env.sh; \
	. $(EMSDK_DIR)/emsdk_env.sh; \
	$(MAKE) -j4 -C ../.. \
		OS=wasm build=release \
		XCFLAGS='-DTOFU -DTOFU_CJK -DFZ_ENABLE_SVG=0 -DFZ_ENABLE_HTML=0 -DFZ_ENABLE_EPUB=0 -DFZ_ENABLE_JS=0' \
		libs

wasm: $(MUPDF_JS) $(MUPDF_WASM)
$(MUPDF_JS) $(MUPDF_WASM) : $(MUPDF_CORE) wrap.c wrap.js
	BASH_SOURCE=$(EMSDK_DIR)/emsdk_env.sh; . $(EMSDK_DIR)/emsdk_env.sh; \
	emcc -Wall -Os -o $@ \
		-s WASM=1 \
		-s VERBOSE=0 \
		-s ABORTING_MALLOC=0 \
		-s TOTAL_MEMORY=134217728 \
		-s EXTRA_EXPORTED_RUNTIME_METHODS='["ccall","cwrap"]' \
		-I ../../include \
		--pre-js wrap.js \
		wrap.c \
		../../build/wasm/release/libmupdf.a \
		../../build/wasm/release/libmupdf-third.a

run: $(SAMPLE_PDF) $(MUPDF_JS) $(MUDPF_WASM)
	python3 -m http.server 8000
	sleep 3
	xdg-open http://127.0.0.1:8000/view.html?file=$(SAMPLE_PDF) &

clean:
	rm -f $(MUPDF_JS) $(MUPDF_WASM)

nuke: clean
	$(MAKE) -C ../../ OS=wasm build=release clean

.PHONY: .FORCE clean

=== debian/changelog ===
mupdf (1.19.0+ds1-2) unstable; urgency=medium

  * d/watch: Follow HTTP redirect
  * Depend on minimum runtime version of jbig2 (Closes: #1005788)

  [ Pino Toscano ]
  * Drop mupdf.xpm, as it was needed for the Debian menu
  * Install app icon in XDG hicolor icon theme
  * Install app icon from docs

 -- Bastian Germann <bage@debian.org>  Tue, 15 Feb 2022 11:33:58 +0100

mupdf (1.19.0+ds1-1) unstable; urgency=medium

  * Revert "Build-Conflict with libssl" (Closes: #969301, #783648, #971449)
  * Depend on libgumbo
  * Update debhelper to v13
  * Refresh patches for v1.19.0
  * d/control: Add Uploader bage
  * d/copyright: Update to match 1.19.0
  * d/copyright: Exclude all thirdparty except 'extract'
  * New upstream version 1.19.0+ds1 (Closes: #974736, #968699)
  * Specifiy jbig2dec version (Closes: #970828)
  * Add missing executables (Closes: #914396)

  [ Jörg-Volker Peetz ]
  * mupdf.sh: Compression with zstandard; replace tempfile (Closes: #968133)

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Celejar ]
  * Only warn once about the missing ICC support (Closes: #952724)

 -- Bastian Germann <bage@debian.org>  Tue, 26 Oct 2021 04:05:12 +0200

=== debian/control ===
Source: mupdf
Section: text
Priority: optional
Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>, Bastian Germann <bage@debian.org>
Build-Depends: debhelper-compat (= 13),
 libfreetype-dev, libgumbo-dev, pkg-config, libjpeg-dev, libjbig2dec0-dev (>= 0.19),
 libmujs-dev, libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
 libharfbuzz-dev, freeglut3-dev, libssl-dev, liblcms2-dev, python3:any
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://mupdf.com/
Vcs-Git: https://salsa.debian.org/koster/mupdf.git
Vcs-Browser: https://salsa.debian.org/koster/mupdf

Package: libmupdf-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: development files for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains the static library and headers.

Package: mupdf
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libjbig2dec0 (>= 0.19)
Suggests: mupdf-tools
Provides: pdf-viewer
Description: lightweight PDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 The renderer in MuPDF is tailored for high quality anti-aliased graphics.
 It renders text with metrics and spacing accurate to within fractions of a
 pixel for the highest fidelity in reproducing the look of a printed page
 on screen.

Package: mupdf-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libjbig2dec0 (>= 0.19)
Description: command line tools for the MuPDF viewer
 MuPDF is a lightweight PDF viewer and toolkit written in portable C.
 It also reads XPS, OpenXPS and ePub documents.
 .
 This package contains command line tools using the MuPDF library:
  - mutool - tool for clean, extract, inspect PDF documents and
             render PDF/XPS/CBZ documents.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable verbose builds to detect missing (hardening) flags.
#export verbose=1

# This has to be exported to make some magic below work.
export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

# Set CC for crossbuild
export CC_FOR_BUILD ?= cc
export PKG_CONFIG ?= $(DEB_HOST_GNU_TYPE)-pkg-config

# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
CFLAGS += $(CPPFLAGS)
# ICC support needs patched thirdparty liblcms2-art
CFLAGS += -DFZ_ENABLE_ICC=0
CFLAGS += -fPIC

BUILD_FLAGS = build=debian OS=Linux XCFLAGS="$(CFLAGS)" XLDFLAGS="$(LDFLAGS)" prefix=/usr
# Force using system library
BUILD_FLAGS += USE_SYSTEM_MUJS=yes
BUILD_FLAGS += USE_SYSTEM_LIBS=yes
# Force using system lcms2 (was not included in default system library set)
BUILD_FLAGS += USE_SYSTEM_LCMS2=yes
BUILD_FLAGS += LD=$(DEB_HOST_GNU_TYPE)-ld


ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -O0
else
    CFLAGS += -O2
endif

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	BUILD_FLAGS += verbose=yes
endif

ifeq ($(DEB_TARGET_ARCH),mips64el)
	BUILD_FLAGS += HAVE_OBJCOPY=no
endif

override_dh_auto_build:
	-mkdir source/pdf/cmaps
	sh scripts/runcmapdump.sh
	dh_auto_build -- $(BUILD_FLAGS)

override_dh_auto_install:
	dh_auto_install -- $(BUILD_FLAGS)
	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make -C $(CURDIR)/debian/tests test
endif

override_dh_auto_clean:
	-rm -rf build
	-rm -rf generated
	-rm -rf source/pdf/cmaps

override_dh_missing:
	dh_missing --list-missing

%:
	dh $@

=== debian/watch ===
version=3
opts=repacksuffix=+ds1,dversionmangle=s/\+ds\d*$//,uversionmangle=s/(\d[^_\-\.]?)[_\-\.](source?)$/$1/ \
https://mupdf.com/releases/ \
(?:.*/|.*=|)mupdf[\-\._]?([0-9.]+)-source\.(?:tar\.xz|tar\.gz)

## mupdf 1.20.0+ds1

=== Makefile ===
--- 
+++ 
@@ -126,7 +126,12 @@
 	$(CC_CMD) $(WARNING_CFLAGS) -Wdeclaration-after-statement $(LIB_CFLAGS) $(THIRD_CFLAGS)
 
 $(OUT)/source/%.o : source/%.cpp
-	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(TESSERACT_BUILD_CFLAGS)
+	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS)
+
+ifeq ($(HAVE_TESSERACT),yes)
+$(OUT)/source/fitz/tessocr.o : source/fitz/tessocr.cpp
+	$(CXX_CMD) $(WARNING_CFLAGS) $(LIB_CFLAGS) $(THIRD_CFLAGS) $(TESSERACT_CFLAGS) $(TESSERACT_DEFINES) $(TESSERACT_LANGFLAGS)
+endif
 
 $(OUT)/platform/%.o : platform/%.c
 	$(CC_CMD) $(WARNING_CFLAGS)
@@ -165,7 +170,7 @@
 
 # --- Generated embedded font files ---
 
-HEXDUMP_EXE := $(OUT)/scripts/hexdump.exe
+HEXDUMP_SH := scripts/hexdump.sh
 
 FONT_BIN := $(sort $(wildcard resources/fonts/urw/*.cff))
 FONT_BIN += $(sort $(wildcard resources/fonts/han/*.ttc))
@@ -176,10 +181,10 @@
 
 FONT_GEN := $(FONT_BIN:%=generated/%.c)
 
-generated/%.cff.c : %.cff $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
-generated/%.otf.c : %.otf $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
-generated/%.ttf.c : %.ttf $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
-generated/%.ttc.c : %.ttc $(HEXDUMP_EXE) ; $(QUIET_GEN) $(MKTGTDIR) ; $(HEXDUMP_EXE) -s $@ $<
+generated/%.cff.c : %.cff $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
+generated/%.otf.c : %.otf $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
+generated/%.ttf.c : %.ttf $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
+generated/%.ttc.c : %.ttc $(HEXDUMP_SH) ; $(QUIET_GEN) $(MKTGTDIR) ; bash $(HEXDUMP_SH) > $@ $<
 
 ifeq ($(HAVE_OBJCOPY),yes)
   MUPDF_OBJ += $(FONT_BIN:%=$(OUT)/%.o)
@@ -234,7 +239,7 @@
 
 ifeq ($(shared),yes)
 MUPDF_LIB = $(OUT)/libmupdf.$(SO)
-ifeq ($(OS),MINGW)
+ifeq ($(SO),dll)
 MUPDF_LIB_IMPORT = $(OUT)/libmupdf_$(SO).a
 LIBS_TO_INSTALL_IN_BIN = $(MUPDF_LIB)
 LIBS_TO_INSTALL_IN_LIB = $(MUPDF_LIB_IMPORT)
@@ -283,13 +288,13 @@
 MUTOOL_SRC += source/tools/cmapdump.c
 MUTOOL_SRC += $(sort $(wildcard source/tools/pdf*.c))
 MUTOOL_OBJ := $(MUTOOL_SRC:%.c=$(OUT)/%.o)
-MUTOOL_EXE := $(OUT)/mutool
+MUTOOL_EXE := $(OUT)/mutool$(EXE)
 $(MUTOOL_EXE) : $(MUTOOL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(THREAD_LIB)
 	$(LINK_CMD) $(THIRD_LIBS) $(THREADING_LIBS) $(LIBCRYPTO_LIBS)
 TOOL_APPS += $(MUTOOL_EXE)
 
 MURASTER_OBJ := $(OUT)/source/tools/muraster.o
-MURASTER_EXE := $(OUT)/muraster
+MURASTER_EXE := $(OUT)/muraster$(EXE)
 $(MURASTER_EXE) : $(MURASTER_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(THREAD_LIB)
 	$(LINK_CMD) $(THIRD_LIBS) $(THREADING_LIBS) $(LIBCRYPTO_LIBS)
 TOOL_APPS += $(MURASTER_EXE)
@@ -297,14 +302,14 @@
 ifeq ($(HAVE_GLUT),yes)
   MUVIEW_GLUT_SRC += $(sort $(wildcard platform/gl/*.c))
   MUVIEW_GLUT_OBJ := $(MUVIEW_GLUT_SRC:%.c=$(OUT)/%.o)
-  MUVIEW_GLUT_EXE := $(OUT)/mupdf-gl
+  MUVIEW_GLUT_EXE := $(OUT)/mupdf-gl$(EXE)
   $(MUVIEW_GLUT_EXE) : $(MUVIEW_GLUT_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(THIRD_GLUT_LIB) $(PKCS7_LIB)
 	$(LINK_CMD) $(THIRD_LIBS) $(LIBCRYPTO_LIBS) $(WIN32_LDFLAGS) $(THIRD_GLUT_LIBS)
   VIEW_APPS += $(MUVIEW_GLUT_EXE)
 endif
 
 ifeq ($(HAVE_X11),yes)
-  MUVIEW_X11_EXE := $(OUT)/mupdf-x11
+  MUVIEW_X11_EXE := $(OUT)/mupdf-x11$(EXE)
   MUVIEW_X11_OBJ += $(OUT)/platform/x11/pdfapp.o
   MUVIEW_X11_OBJ += $(OUT)/platform/x11/x11_main.o
   MUVIEW_X11_OBJ += $(OUT)/platform/x11/x11_image.o
@@ -314,7 +319,7 @@
 endif
 
 ifeq ($(HAVE_WIN32),yes)
-  MUVIEW_WIN32_EXE := $(OUT)/mupdf-w32
+  MUVIEW_WIN32_EXE := $(OUT)/mupdf-w32$(EXE)
   MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/pdfapp.o
   MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/win_main.o
   MUVIEW_WIN32_OBJ += $(OUT)/platform/x11/win_res.o
@@ -326,7 +331,7 @@
 ifeq ($(HAVE_X11),yes)
 ifeq ($(HAVE_CURL),yes)
 ifeq ($(HAVE_PTHREAD),yes)
-  MUVIEW_X11_CURL_EXE := $(OUT)/mupdf-x11-curl
+  MUVIEW_X11_CURL_EXE := $(OUT)/mupdf-x11-curl$(EXE)
   MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/pdfapp.o
   MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_main.o
   MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_image.o
@@ -369,17 +374,3 @@
 VERSION = $(shell git describe --tags)
 
 version:
-	sed -i~ -e '/FZ_VERSION /s/".*"/"'$(VERSION)'"/' include/mupdf/fitz/version.h
-
-# --- Format man pages ---
-
-%.txt: %.1
-	nroff -man $< | col -b | expand > $@
-
-MAN_FILES := $(sort $(wildcard docs/man/*.1))
-TXT_FILES := $(MAN_FILES:%.1=%.txt)
-
-catman: $(TXT_FILES)
-
-# --- Install ---
-

=== platform/java/Makefile ===
--- 
+++ 
@@ -29,7 +29,7 @@
 JAVA_CFLAGS := \
 	-I $(JAVA_VM)/include \
 	-I $(JAVA_VM)/include/darwin
-JAVA_LDFLAGS :=
+JAVA_LDFLAGS := -lstdc++
 
 else
 
@@ -50,22 +50,25 @@
 JAVA_LDFLAGS := \
 	-z noexecstack
 
-ifeq ($(USE_TESSERACT), yes)
+ifeq ($(tesseract), yes)
 ifeq ($(USE_SYSTEM_TESSERACT), yes)
 JAVA_LIBS += \
 	$(shell pkg-config --libs lept) \
 	$(shell pkg-config --libs tesseract)
 
-CONFIGFLAGS += USE_SYSTEM_TESSERACT=yes
+CONFIGFLAGS += tesseract=yes USE_SYSTEM_TESSERACT=yes
 else
-CONFIGFLAGS += USE_TESSERACT=yes
+CONFIGFLAGS += tesseract=yes
 endif
 endif
 endif
 
 MUPDF_JAR := ../../$(OUT)/libmupdf.jar
 
-default: $(MUPDF_JAVA) $(MUPDF_JAR) $(EXAMPLE_JAVA_SOURCES)
+EXAMPLE_JAVA_SOURCES := $(sort $(wildcard example/*.java))
+EXAMPLE_JAVA_OBJECTS := $(subst example/,../../$(OUT)/example/,$(EXAMPLE_JAVA_SOURCES:%.java=%.class))
+
+default: $(MUPDF_JAVA) $(MUPDF_JAR) $(EXAMPLE_JAVA_OBJECTS)
 
 MUPDF_CORE := ../../$(OUT)/libmupdf.a ../../$(OUT)/libmupdf-third.a
 ifeq "$(OS)" "Linux"
@@ -85,9 +88,6 @@
 $(LIBRARY_JAVA_OBJECTS) : $(LIBRARY_JAVA_SOURCES)
 	mkdir -p ../../$(OUT)
 	$(JAVAC) $(JAVAC_FLAGS) -h ../../$(OUT)/ -d ../../$(OUT)/ $^
-
-EXAMPLE_JAVA_SOURCES := $(sort $(wildcard example/*.java))
-EXAMPLE_JAVA_OBJECTS := $(subst example/,../../$(OUT)/example/,$(EXAMPLE_JAVA_SOURCES:%.java=%.class))
 
 $(EXAMPLE_JAVA_OBJECTS): $(EXAMPLE_JAVA_SOURCES)
 	$(JAVAC) $(JAVAC_FLAGS) -classpath ../../$(OUT) -d ../../$(OUT)/ $^
@@ -123,6 +123,7 @@
 	rm -fr ../../$(OUT)/thirdparty
 	rm -f $(MUPDF_JAR)
 	rm -f $(MUPDF_JAVA)
+	rm -f $(MUPDF_CORE)
 	rm -f ../../$(OUT)/*.h
 
 nuke: clean

=== platform/wasm/Makefile ===
-include ../../user.make

ifndef build
  build := release
endif

ifeq ($(build),debug)
  BUILD_FLAGS := \
	-Wall -O0 \
	-s VERBOSE=0 \
	-s ABORTING_MALLOC=0 \
	-s ALLOW_MEMORY_GROWTH=1
else
  BUILD_FLAGS := \
	-Wall -Os \
	-s VERBOSE=0 \
	-s ABORTING_MALLOC=0 \
	-s ALLOW_MEMORY_GROWTH=1
endif

ifndef BUILD_DIR
  BUILD_DIR := ../../build/wasm/$(build)
endif

ifndef EMSDK_DIR
  EMSDK_DIR := /opt/emsdk
endif

ifndef SAMPLE_PDF
  SAMPLE_PDF := pdfref13.pdf
endif

MUPDF_JS := libmupdf.js
MUPDF_WASM := libmupdf.wasm


all: $(MUPDF_JS)

MUPDF_CORE := $(BUILD_DIR)/libmupdf.a $(BUILD_DIR)/libmupdf-third.a
$(MUPDF_CORE): .FORCE
	$(MAKE) -j4 -C ../.. generate
	BASH_SOURCE=$(EMSDK_DIR)/emsdk_env.sh; \
	. $(EMSDK_DIR)/emsdk_env.sh; \
	$(MAKE) -j4 -C ../.. \
		OS=wasm build=$(build) \
		XCFLAGS='-DTOFU -DTOFU_CJK -DFZ_ENABLE_SVG=0 -DFZ_ENABLE_HTML=0 -DFZ_ENABLE_EPUB=0 -DFZ_ENABLE_JS=0' \
		libs

wasm: $(MUPDF_JS) $(MUPDF_WASM)
$(MUPDF_JS) $(MUPDF_WASM): $(MUPDF_CORE) wrap.c wrap.js
	BASH_SOURCE=$(EMSDK_DIR)/emsdk_env.sh; . $(EMSDK_DIR)/emsdk_env.sh; \
	emcc -o $@ $(BUILD_FLAGS) \
		-s WASM=1 \
		-s EXPORTED_RUNTIME_METHODS='["ccall","cwrap"]' \
		-s EXPORTED_FUNCTIONS='["_malloc","_free"]' \
		-I ../../include \
		--pre-js wrap.js \
		wrap.c \
		$(BUILD_DIR)/libmupdf.a \
		$(BUILD_DIR)/libmupdf-third.a

run: $(SAMPLE_PDF) $(MUPDF_JS) $(MUDPF_WASM)
	python3 -m http.server 8000
	sleep 3
	xdg-open http://127.0.0.1:8000/view.html?file=$(SAMPLE_PDF) &

clean:
	rm -f $(MUPDF_JS) $(MUPDF_WASM)
	$(MAKE) -C ../../ OS=wasm build=$(build) clean

.PHONY: .FORCE clean

=== debian/changelog ===
mupdf (1.20.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.20.0+ds1
  * Drop one unnecessary patch hunk
  * d/copyright: Reflect new version's changes

 -- Bastian Germann <bage@debian.org>  Sat, 18 Jun 2022 21:58:29 +0200

## mupdf 1.20.3+ds1

=== debian/changelog ===
mupdf (1.20.3+ds1-1) unstable; urgency=medium

  * New upstream version 1.20.3+ds1

 -- Bastian Germann <bage@debian.org>  Mon, 15 Aug 2022 23:07:44 +0200

## mupdf 1.21.0+ds1

=== debian/changelog ===
mupdf (1.21.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.21.0+ds1
  * Fix lintian by test compiling with hardening flags
  * Add LDFLAGS to test compile
  * d/copyright: Remove zlib license

 -- Bastian Germann <bage@debian.org>  Tue, 08 Nov 2022 20:45:48 +0100

## mupdf 1.21.1+ds1

=== Makefile ===
--- 
+++ 
@@ -174,10 +174,43 @@
 
 FONT_BIN := $(sort $(wildcard resources/fonts/urw/*.cff))
 FONT_BIN += $(sort $(wildcard resources/fonts/han/*.ttc))
-FONT_BIN += $(sort $(wildcard resources/fonts/droid/*.ttf))
+FONT_BIN += $(sort $(wildcard resources/fonts/droid/DroidSansFallbackFull.ttf))
+FONT_BIN += $(sort $(wildcard resources/fonts/droid/DroidSansFallback.ttf))
 FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.otf))
 FONT_BIN += $(sort $(wildcard resources/fonts/noto/*.ttf))
 FONT_BIN += $(sort $(wildcard resources/fonts/sil/*.cff))
+
+# Note: The tests here must match the equivalent tests in noto.c
+
+ifneq ($(filter -DTOFU_CJK,$(XCFLAGS)),)
+  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
+  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallbackFull.ttf, $(FONT_BIN))
+  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallback.ttf, $(FONT_BIN))
+endif
+
+ifneq ($(filter -DTOFU_CJK_EXT,$(XCFLAGS)),)
+  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
+  FONT_BIN := $(filter-out resources/fonts/droid/DroidSansFallbackFull.ttf, $(FONT_BIN))
+endif
+
+ifneq ($(filter -DTOFU_CJK_LANG,$(XCFLAGS)),)
+  FONT_BIN := $(filter-out resources/fonts/han/%.ttc, $(FONT_BIN))
+endif
+
+ifneq ($(filter -DTOFU,$(XCFLAGS)),)
+  FONT_BIN := $(filter-out resources/fonts/noto/%.otf,$(FONT_BIN))
+  FONT_BIN := $(filter-out resources/fonts/noto/%.ttf,$(FONT_BIN))
+  FONT_BIN := $(filter-out resources/fonts/sil/%.cff,$(FONT_BIN))
+endif
+
+ifneq ($(filter -DTOFU_NOTO,$(XCFLAGS)),)
+  FONT_BIN := $(filter-out resources/fonts/noto/%.otf,$(FONT_BIN))
+  FONT_BIN := $(filter-out resources/fonts/noto/%.ttf,$(FONT_BIN))
+endif
+
+ifneq ($(filter -DTOFU_SIL,$(XCFLAGS)),)
+  FONT_BIN := $(filter-out resources/fonts/sil/%.cff,$(FONT_BIN))
+endif
 
 FONT_GEN := $(FONT_BIN:%=generated/%.c)
 
@@ -333,44 +366,3 @@
 ifeq ($(HAVE_PTHREAD),yes)
   MUVIEW_X11_CURL_EXE := $(OUT)/mupdf-x11-curl$(EXE)
   MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/pdfapp.o
-  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_main.o
-  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/x11_image.o
-  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/curl_stream.o
-  MUVIEW_X11_CURL_OBJ += $(OUT)/platform/x11/curl/prog_stream.o
-  $(MUVIEW_X11_CURL_EXE) : $(MUVIEW_X11_CURL_OBJ) $(MUPDF_LIB) $(THIRD_LIB) $(PKCS7_LIB) $(CURL_LIB)
-	$(LINK_CMD) $(THIRD_LIBS) $(X11_LIBS) $(LIBCRYPTO_LIBS) $(CURL_LIBS) $(PTHREAD_LIBS)
-  VIEW_APPS += $(MUVIEW_X11_CURL_EXE)
-endif
-endif
-endif
-
-# --- Generated dependencies ---
-
--include $(MUPDF_OBJ:%.o=%.d)
--include $(PKCS7_OBJ:%.o=%.d)
--include $(THREAD_OBJ:%.o=%.d)
--include $(THIRD_OBJ:%.o=%.d)
--include $(THIRD_GLUT_OBJ:%.o=%.d)
-
--include $(MUTOOL_OBJ:%.o=%.d)
--include $(MUVIEW_GLUT_OBJ:%.o=%.d)
--include $(MUVIEW_X11_OBJ:%.o=%.d)
--include $(MUVIEW_WIN32_OBJ:%.o=%.d)
-
--include $(MURASTER_OBJ:%.o=%.d)
--include $(MUVIEW_X11_CURL_OBJ:%.o=%.d)
-
-# --- Examples ---
-
-examples: $(OUT)/example $(OUT)/multi-threaded
-
-$(OUT)/example: docs/examples/example.c $(MUPDF_LIB) $(THIRD_LIB)
-	$(LINK_CMD) $(CFLAGS) $(THIRD_LIBS)
-$(OUT)/multi-threaded: docs/examples/multi-threaded.c $(MUPDF_LIB) $(THIRD_LIB)
-	$(LINK_CMD) $(CFLAGS) $(THIRD_LIBS) -lpthread
-
-# --- Update version string header ---
-
-VERSION = $(shell git describe --tags)
-
-version:

=== debian/changelog ===
mupdf (1.21.1+ds1-2) unstable; urgency=medium

  * Team upload
  * Add fallback for missing SA_NOCLDWAIT (Closes: #1028919)

  [ Debian Janitor ]
  * Trim trailing whitespace
  * Use secure URI in Homepage field
  * Update standards version to 4.6.2, no changes needed

 -- Bastian Germann <bage@debian.org>  Sun, 15 Jan 2023 01:38:15 +0100

mupdf (1.21.1+ds1-1) unstable; urgency=medium

  * New upstream version 1.21.1

 -- Bastian Germann <bage@debian.org>  Thu, 15 Dec 2022 21:01:30 +0100

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
  libfreetype-dev, libgumbo-dev, pkg-config, libjpeg-dev, libjbig2dec0-dev (>= 0.19),
  libmujs-dev, libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
  libharfbuzz-dev, freeglut3-dev, libssl-dev, liblcms2-dev, python3:any
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: http://mupdf.com/
+Homepage: https://mupdf.com/
 Vcs-Git: https://salsa.debian.org/koster/mupdf.git
 Vcs-Browser: https://salsa.debian.org/koster/mupdf

=== debian/rules ===
--- 
+++ 
@@ -56,7 +56,7 @@
 	dh_auto_install -- $(BUILD_FLAGS)
 	install -m744 -T $(CURDIR)/debian/mupdf.sh $(CURDIR)/debian/tmp/usr/bin/mupdf
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	make -C $(CURDIR)/debian/tests test
+	$(MAKE) -C $(CURDIR)/debian/tests test
 endif
 
 override_dh_auto_clean:
